package com.wechi.adweb.bridge.google.ads.dto;

import com.google.ads.googleads.v18.common.Metrics;
import com.google.ads.googleads.v18.resources.Campaign;
import com.google.ads.googleads.v18.resources.CampaignBudget;
import com.google.ads.googleads.v18.services.GoogleAdsRow;

import lombok.Builder;
import lombok.Data;

/**
 * @author wfansh
 */
@Data
@Builder
public class CampaignStatsDTO {

    private String resourceName;
    private String name;

    private String status;
    private String primaryStatus;
    private String advertisingChannelType;
    private String advertisingChannelSubType;
    private String biddingStrategyType;

    private long budgetMicros;

    private MetricsDTO metrics;

    public static CampaignStatsDTO fromGoogleAdsRow(GoogleAdsRow googleAdsRow) {
        Campaign campaign = googleAdsRow.getCampaign();
        CampaignBudget campaignBudget = googleAdsRow.getCampaignBudget();
        Metrics metrics = googleAdsRow.getMetrics();
        return CampaignStatsDTO.builder()
                .resourceName(campaign.getResourceName())
                .name(campaign.getName())
                .status(campaign.getStatus().name())
                .primaryStatus(campaign.getPrimaryStatus().name())
                .advertisingChannelType(campaign.getAdvertisingChannelType().name())
                .advertisingChannelSubType(campaign.getAdvertisingChannelSubType().name())
                .biddingStrategyType(campaign.getBiddingStrategyType().name())
                .budgetMicros(campaignBudget.getAmountMicros())
                .metrics(MetricsDTO.fromMetrics(metrics))
                .build();
    }
}
