package com.wechi.adweb.bridge.google.ads.dto;

import com.google.ads.googleads.v18.common.Metrics;

import lombok.Builder;
import lombok.Data;

/**
 * @author wfansh
 */
@Data
@Builder
public class MetricsDTO {

    private long impressions;
    private long clicks;

    private double ctr;
    private double averageCpc;
    private double averageCpm;

    private double conversions;

    private long costMicros;

    public MetricsDTO merge(MetricsDTO metricsDTO) {
        this.impressions += metricsDTO.impressions;
        this.clicks += metricsDTO.clicks;

        this.ctr = Math.max(this.ctr, metricsDTO.ctr);
        this.averageCpc = Math.max(this.averageCpc, metricsDTO.averageCpc);
        this.averageCpm = Math.max(this.averageCpm, metricsDTO.averageCpm);

        this.conversions += metricsDTO.conversions;

        this.costMicros += metricsDTO.costMicros;

        return this;
    }

    public static MetricsDTO fromMetrics(Metrics metrics) {
        return MetricsDTO.builder()
                .impressions(metrics.getImpressions())
                .clicks(metrics.getClicks())
                .ctr(metrics.getCtr())
                .averageCpc(metrics.getAverageCpc())
                .averageCpm(metrics.getAverageCpm())
                .conversions(metrics.getConversions())
                .costMicros(metrics.getCostMicros())
                .build();
    }
}
