package com.wechi.adweb.bridge.google.ads;

import com.wechi.adweb.bridge.exception.DataException;
import com.wechi.adweb.bridge.google.ads.dto.CustomerStatsDTO;
import com.wechi.adweb.bridge.google.ads.dto.ReportRequestDTO;
import com.wechi.adweb.bridge.google.ads.service.GoogleAdsService;
import com.wechi.adweb.bridge.util.JsonUtils;

import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;

/**
 * @author wfansh
 */
@SpringBootTest
public class GoogleAdsServiceTest {

    @Autowired private GoogleAdsService googleAdsService;

    private final String customerId = "7703736321";

    @Test
    void testGetCustomerStats() throws DataException {
        CustomerStatsDTO customerStats = googleAdsService.getCustomerStats(customerId);
        System.out.println(JsonUtils.toJson(customerStats));
    }

    @Test
    void test() throws DataException {
        ReportRequestDTO reportRequest = new ReportRequestDTO();
        reportRequest.setCustomerId(customerId);
        reportRequest.setStartDate("2024-12-01");
        reportRequest.setEndDate("2024-12-06");
        reportRequest.setLimit(100);

        System.out.println(JsonUtils.toJson(googleAdsService.getDailyStats(reportRequest)));
    }
}
